#!/usr/local/bin/perl -wT
# Copyright Andru Luvisi, 1999
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program (see the file COPYING); if not, write to the
# Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA


use CGI;
use CGI::Carp qw(fatalsToBrowser);
use HTML::Template;
use strict;


use vars qw(@templates $query $template $template_file $compat $i);
use vars qw($master_template $master_template_file);

@templates = (
	[ 0, "num/zero.tmpl" ], # needed.
	[ 10, "num/ten.tmpl" ],
	[ 20, "num/twenty.tmpl" ],
	[ 30, "num/thirty.tmpl" ],
	[ 40, "num/forty.tmpl" ],
	[ 50, "num/fifty.tmpl" ],
	[ 60, "num/sixty.tmpl" ],
	[ 69, "num/sixtynine.tmpl" ],
	[ 70, "num/seventy.tmpl" ],
	[ 80, "num/eighty.tmpl" ],
	[ 90, "num/ninety.tmpl" ],
	[ 99, "num/ninetynine.tmpl" ],
);

$master_template_file = "numerology.tmpl";

$query = CGI->new();
$compat = compat(join("", $query->param("person1"), $query->param("person2")));
for($i=0; $i < @templates; $i++) {
 if($compat >= $templates[$i][0]) {
  $template_file = $templates[$i][1];
 }
}

$template = HTML::Template->new(filename => $template_file,
				die_on_bad_params => 0);
$template->param("compat", $compat);
$template->param("person1", $query->param("person1"));
$template->param("person2", $query->param("person2"));

$master_template = HTML::Template->new(filename => $master_template_file,
					die_on_bad_params => 0);
$master_template->param("compat", $compat);
$master_template->param("person1", $query->param("person1"));
$master_template->param("person2", $query->param("person2"));
$master_template->param("message", $template->output());

print $query->header(), $master_template->output(), "\n";

exit(0);

sub compat {
 my ($names, $number, $pat, $tries) = (shift, "", "", 0);

 ($number = "LOVES") =~ s/./$pat = $&; $#{[ $names =~ m($pat)gi]} + 1/ge;

 $number =~ s/(.)(?=(.))/$1+$2/eg && chop $number
     while $number =~ /^.{3,100}$/ && ++$tries < 100;

 return $number =~ /^..?$/ ? $number : 0;
}

